{
What is   : Key Array
            =========
Maded for : QParam
Date      : Jan 98
Autor     : Nikolay Mihaylov

            NMMM@NSI.BG
            NMMM@HotMail.Com

            Http://WWW.NSI.BG/NMMM/Home.Htm

}

Unit KeyArr;

InterFace

Const KeyArrMax  = 30;
Type  TKeyArrRec = Record
                      Key,
                      Value : String[30];
                   End;
      TKeyArr    = Class(TObject)
                      M  : Array [1..KeyArrMax] Of TKeyArrRec;
                      Br : Byte;

                      Constructor Create; Virtual;

                      Procedure   Clear;

                      Function    Exist(S:String):Byte;

                      Procedure   Add(S:String);

                      Procedure   SetValue(S,V:String);
                      Function    GetValue(S:String):String;

                      Procedure Sort;
                   End;


Implementation

Constructor TKeyArr.Create;
   Begin
      Inherited Create;
      Clear;
   End;

Procedure TKeyArr.Clear;
   Begin
      Br:=0;
   End;

Procedure TKeyArr.Sort;
   Var I,
       J    : Byte;
       Temp : TKeyArrRec;
   Begin
      If Br > 1 Then
         For J:=1 To Br - 1 Do
            For I:=1 To Br - 1 Do
               If M[I].Key > M[I + 1].Key Then
                  Begin
                     Temp:=M[I];
                     M[I]:=M[I + 1];
                     M[I + 1]:=Temp;
                  End;
   End;

Function  TKeyArr.Exist(S:String):Byte;
   Var I : Byte;
   Begin
      Exist:=0;
      If Br > 0 Then
         For I:=1 To Br Do
             If S = M[I].Key Then
                Exist:=I;
   End;

Procedure TKeyArr.Add(S:String);
   Begin
      If (Exist(S) = 0  ) And
         (Br < KeyArrMax) Then
         Begin
            Inc(Br);
            M[Br].Key:=S;
            M[Br].Value:='';
            Sort;
         End;
   End;

Procedure TKeyArr.SetValue(S,V:String);
   Begin
      If Exist(S) <> 0 Then
         M[Exist(S)].Value:=V
      Else
         Begin
            Add(S);
            If Exist(S) <> 0 Then
               M[Exist(S)].Value:=V;
         End;
   End;

Function  TKeyArr.GetValue(S:String):String;
   Begin
      If Exist(S) = 0 Then
         GetValue:=''
      Else
         GetValue:=M[Exist(S)].Value;
   End;

End.

